#################################################
#Patchfile for KUBED				#
#################################################

#################################################
#FILES						#
#################################################

%ext ck4
#Text plane starts at $2EE70 2EE70
#Spare text starts at $3D740 = +E8D0 (5935 sp)
%maphead maphead.ck4
%egahead EGAHEAD.CK4				#New graphics
%patchfile $20DF0 AUDIOHED.CK4			#Patch the Audiohead [652bytes]
%patchfile $249C2 Keen4.tli			#New tile properties

#Testlevel
%patch $5209        $0002W #Diff
%patch $5CBB $7A68W $0000w #Startlev
%patch $5CCD $7A5EW $0000W #Nextlv
%patch $5CC1 $7A54W $0000W #EKA is 0
%patch $5CC7 $7A6AW $0000W #Lives is 0

#Remove keys from END cheat -F
%patch $9127 $90 $90 #E
%patch $912E $90 $90 #N
%patch $9132 $C689W #D


#################################
#Game				#
#################################

#Disable help
%patch $3F09  $EB     #Unknown, initiation screen?
%patch $51AB  $EB     #During terminator text
%patch $7930  $EB     #In game levels
%patch $1CED9 $90 $90 #In Main Menu

#Remove compression
%patch $12D2C $55 $8B $EC $56 $57 $8C $DA $C4 $7E $0A $C5 $76 $06 $8B $4E $0E $D1
              $E9 $FC $F3 $A5 $73 $01 $A4 $8E $DA $5F $5E  $5D $CB

#Disable status window
%patch $78B2 $EB $30

#Always use WoW scrolling
%patch $905B $EB

#Disable EKA
%patch $8AD1 $5D $CB

#Disable two button firing -Keen 4
%patch $8B84 $E9 $0096W

#Terminator sequence goes straight to title
%patch $50ED $A545W $001CW

#Disable single demos -Keen 4
%patch $3C32 $90 $90 $90 $90 $90 #Demo 1
%patch $3C47 $90 $90 $90 $90 $90 #Demo 2
%patch $3C5C $90 $90 $90 $90 $90 #Demo 3
%patch $3C6C $90 $90 $90 $90 $90 #Demo 4 

#Variables
#1427W: Keen's h position
#142AW: Keen's v position
#7A1EW: Levswitch: Alters all general Miragia
#7A20W: Opswitch; alters onscreen Miragia
#7A22W: Time left
#7A24W: Cubes left
#7A26W: OnFloor: detects if Keen is on anim-changing floor
#7A28W: Death state for ghosting, death messages, nocounter
#7A2AW: Dropsound: Sound and behavior of type 2 items
#7A2CW: Pushbutton; stops continual behaviors
#7A2EW: Palette state
#7A30W: Trap state
#7A32W: Global toggle
#7A34W: Local toggle
#7A36W: Tank push
#7A38W: Yellow push
#7A3AW: Clone push
#7A3CW: Onfloor\Ontrap
#7A3EW: Gotice
#7A40W: Gotfire
#7A42W: Gotforce
#7A44W: Gotflip
#7A50W: Score high
#7A52W: Score low
#7A54W: Score store high
#7A56W: Score store low
#7A5CW: Death count
#7A5EW: Current level (Inc at level end)

#Playerstate
#0-normal 1-exiting 2-counterstrike 3-slime
#4-suicide 5-timeout 6-creature 7-moveblock
#8-fire 9-water 10-bomb

#Decs
#Action: 112A
#Space at Keen spawn DE5E-DF1D


#################################
#Cheats				#
#################################

#Demo mode doesn't disable cheats
%patch $7971 $EB

#Disable unwanted cheats
#%patch $7467 $EB $35 #Disable Keen 4 F10-D (Frees 53 bytes at $7469)

#BAT cheat (Now F10 cheat) flips cheat mode variable
%patch $7830 $55 $8B $EC $56 $B8 $0003W  $50 $B8 $0010W  $50 $9A $19311070RL 
         $83 $C4 $04 $83 $3E $7A16W  $00 $75 $05 $B8 $05C5W  $EB $03 $B8 $05D3W
                 $50 $9A $19310E1FRL     $83 $C4 $02 $9A $1D060A9BRL     $9A
             $14600EDFRL     $9A $16540D59RL     $83 $36 $7A16W  $01 $5E $5D $CB

#Keys (F10)
%patch $7A9B $C6CFW  $00 $75 $0E $EB $10

#Text
%patch $2F435 "Cheat mode ON" $00
%patch $2F443 "Cheat mode OFF" $00

#Remove F10 press for cheats after mode activated
%patch $7ABE $90 $90

#Jump cheat now lets Keen ghost
%patch $7581 $83 $3E $C68FW  $00 $74 $4E $83 $36 $C62BW  $01 $9A $1D060999RL
                 $B8 $0003W  $50 $B8 $0012W  $50 $9A $19311070RL     $83 $C4
             $04 $83 $3E $C62BW  $00 $74 $0E $B8 $052DW  $50 $9A $19310E1FRL
                 $83 $C4 $02 $EB $0C $B8 $053BW  $50 $9A $19310E1FRL     $83
             $C4 $02 $9A $1D060A9BRL     $9A $14600EDFRL     $B8 $0001W  $5F
             $5E $8B $E5 $5D $CB

#Text
%patch $2F39D "Ghosting ON" $00
%patch $2F3AB "Ghosting OFF" $00

#Warp cheat can access 10 levels
%patch $77E4 $0A
%patch $2F430 "10"

#Boss cheat activated by 'q'; also allows levelskip cheat
%patch $7A3F $10 $75 $14

#Boss cheat now causes Keen to suicide but not on winning (Free $7A4F-$7A98)
%patch $7A42 $83 $3E $7A28W  $01 $77 $50 $C7 $06 $7A28W  $0003W  $9A $0B8013E9RL     $EB $43

#Mercy levelskip 'cheat' if dc > 20 (Clears score too)
%patch $7A56 $80 $3E $A545W  $0D $75 $3C $83 $3E $7A5CW  $14 $72 $35 $B8 $0E1EW
                 $50 $FF $36 $D6 $A7 $9A $09DC120ARL     $83 $C4 $04 $33 $C0
             $A3 $7A4CW  $A3 $7A4EW  $EB $1B


#################################
#Pause window and game saving	#
#################################

#Disable F10-P cheat TEMP
%patch $75F0 $77

#Key that activates Pause window -Keen 4
%patch $78E6 $C679W

#Loading a game changes stat
%patch $1BE03 $C645W

#Pause key pauses game - and darkens the screen!
%patch $78EB $A0 $4E $A5 $A2 $4ED5W  $8C $D8 $8E $C0 $BA $4EC5W  $B8 $1002W 
             $CD $10 $C7 $06 $C757W  $0000W  $9A $14600EDFRL     $A0 $4E $A5
             $A2 $4EF7W  $8C $D8 $8E $C0 $BA $4EE7W  $B8 $1002W  $CD $10 $C7
             $06 $C757W  $0000W  $EB $09


#################################
#Story				#
#################################

#Story read from
%patch $5582 $1EE3RW #This * $10
%patch $5587 $0004W  #Plus this

#Story text file
%patchfile $1EE34 "STORY.CK4"


#################################
#Levels				#
#################################

#Store Keen's score on level load (And set sound) -unset on Keen's death
%patch $69E8 $A1 $7A50W  $A3 $7A54W  $A1 $7A52W  $A3 $7A56W $C7 $06 $7A2AW
             $000AW  $EB $37

#Win level code; increment level by 1, if maxlev then win game
%patch $6B1E $FF $06 $7A5EW  $B8 $000DW  $50 $9A $187409F1RL     $83 $C4 $02 #Inc CurLev
             $A1 $7A5EW  $A3 $7A68W  $A1 $A7EDW  $A3 $A7C2W  $B8 $0030W  $50 #Load
             $33 $C0 $50 $B8 $7A1EW  $50 $9A $00001D25RL     $83 $C4 $06 $83 #Clear variables
             $3E $7A5EW  $0A $72 $48 $EB $9C

#Where level entry text list is located:
%patch $6274 $1ADCW
%patch $6270 $1ADEW

#Level names
%patch $1F100 "Lesson 1" $00
              "Lesson 2" $00
              "Lesson 3" $00
              "Lesson 4" $00
              "Level 1" $00
              "Level 2" $00
              "Level 3" $00
              "Level 4" $00
              "Level 5" $00
              "Level 6" $00
              "Level 7" $00
              "Level 8" $00
              "Level 9" $00

#Level pointers
%patch $3094C $1F000100RL #Lesson 1
              $1F000109RL #Lesson 2
              $1F000112RL #Lesson 3
              $1F00011BRL #Lesson 4
              $1F000124RL #Level 1
              $1F00012CRL #Level 2
              $1F000134RL #Level 3
              $1F00013CRL #Level 4
              $1F000144RL #Level 5
              $1F00014CRL #Level 6
              $1F000154RL #Level 7
              $1F00015CRL #Level 8
              $1F000164RL #Level 9


#################################
#Cube and time counters		#
#################################

#Create three kinds of time initializers; 1x, 10x, 100x
%patch $EE8D $008CW #1x time
%patch $EE8F $0087W #10x time
%patch $EE91 $0082W #100x time
%patch $EE93 $009DW #1x cubes
%patch $EE95 $0098W #10x cubes
%patch $EE97 $0093W #100x cubes

#Initiation codes (Snowball variables!)
%patch $E972 $83 $06 $7A22W  $5A $83 $06 $7A22W  $09 $FF $06 $7A22W  $E9 $047AW #Time
%patch $E983 $83 $06 $7A24W  $5A $83 $06 $7A24W  $09 $FF $06 $7A24W  $EB $43    #Cubes

#Time counter spawn (Sets sprite to always active) =$0B80000ERL
%patch $B80E $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0001W  $C7 $47 $02 $0002W  $8B $46 $06 $89 $47
             $0A $8B $46 $08 $89 $47 $0C $C7 $47 $1C $098CW  $5D $CB

#Time counter action =$098CW
%patch $2F7FC $0000W $0000W $0000W $0000W $0000W $0040W $0000W $0000W
              $0B80003CRL   $00000000L    $09DC176ERL   $098CW

#Time counter behavior (Dec time counter 1 each cycle) =$0B80003CRL
%patch $B83C  $55 $8B $EC $56 $57 $8B $7E $06 $83 $3E $7A28W  $00 $74 $0F $83 #If playstate=0 skip
              $3E $7A28W  $02 $75 $1A $C7 $06 $7A28W  $0000W  $EB $12 $83 $3E #If 2->0, goto vanish
              $7A22W  $00 $75 $12 $C7 $06 $7A28W  $0004W  $9A $0B8013E9RL     #If t=0 die, vanish
              $C7 $45 $1C $0000W  $EB $23 $FF $0E $7A22W  $83 $3E $7A22W  $1E #Dec t s1=30s
              $77 $18 $83 $3E  $7A22W $0A $77 $05 $B8 $0030W  $EB $03 $B8     #s2=10s
          $0032W  $50 $9A $187409F1RL     $83 $C4 $02 $5F $5E $5D $CB         #Playsound


#################################
#High scores			#
#################################

#Don't show Members saved in High Scores
%patch $5A36 $25

#Horizontal position of score name
%patch $5A1F $0038W

#Horizontal position of scores
%patch $5A9A $0118W

#Default score names and scores
%patch $33234 "CREDITS          " $00
%patch $33274 "                 " $00
%patch $332B4 "Lass: Mod        " $00
%patch $332F4 "Fleex: Abiathar  " $00
%patch $33334 "S.Pavlina: Music " $00
%patch $33374 "Lemm: Title      " $00
%patch $333B4 "ID: Original game" $00
%patch $333F4 "You: Player      " $00

#Default scores (Multiples of 500K)
%patch $3326E $00001F40L
%patch $332AE $00001B58L
%patch $332EE $00001770L
%patch $3332E $00001388L
%patch $3336E $00000FA0L
%patch $333AE $00000BB8L
%patch $333EE $000007D0L
%patch $3342E $000003E8L


#################################
#Death window			#
#################################

#Texts changed
%patch $2F16F "OOPS!" $00
%patch $2F187 "OK" $00

#Death text list (Replaces old level name list)
%patch $663C  $7A28W #What defines what entry to read
%patch $6648  $18F4W 
%patch $6644  $18F6W
%patch $30764 $1F50017BRL #Normal state
              $1F50017BRL #Exiting
              $1F50017BRL #Counterstrike
              $1F5000A0RL #Slime
              $1F5000B5RL #Suicide
              $1F5000CCRL #Timeout
              $1F5000D9RL #Enemy
              $1F5000F5RL #Moving cube
              $1F500114RL #Fire
              $1F500144RL #Water
              $1F500166RL #Bomb
              $1F50017BRL #Twit

#Death texts
%patch $1F5A0 "Don't step in slime!" $00
              "Better luck next" $0A
              "time!" $00
              "Out of time!"  $00
              "Watch out for moving" $0A
              "cubes!" $00
              "Push cubes and they" $0A
              "push back!" $00
              "Don't step on hot stuff" $0A
              "without asbestos shoes!" $00
              "You can't swim without" $0A
              "a wetsuit!" $00
              "Push bomb, get boom!" $00
              "Twit!"

#Inc deathcount, if >50 game over
%patch $667E $FF $06 $7A5CW  $83 $3E $7A5CW  $31 $7E

#Remove 'Exit' text and reset cube counter
%patch $66F5 $C7 $06 $7A58W $0000W $EB $04

#Only one option in window
%patch $6989 $E9 $FD7FW

#Either selected option retries level
%patch $6971 $5F $5E $8B $E5 $5D $CB

#Any key restarts level
%patch $6967 $00 $75

#Locations
%patch $66C5 $08    #How far down level names are from 'Didn't' text
%patch $66B6 $16    #How far down from level names options are

#Change flasher to enclose 'OK' -left
%patch $6748 $0036W #Topmost
%patch $6767 $0036W #Top
%patch $6788 $0036W #Bottom
%patch $67A9 $0036W #Bottommost
%patch $67B9 $0036W #Side 1
%patch $67D3 $0037W #Side 2

#Change flasher to enclose 'OK' -right
%patch $6741 $0038W #Topmost
%patch $6760 $0038W #Top
%patch $6781 $0038W #Bottom
%patch $67A2 $0038W #Bottommost
%patch $67F1 $0038W #Side 3
%patch $680F $0039W #Side 4

#Change flasher to enclose 'OK' -height
%patch $66D6 $08    #Recloc
%patch $6776 $0019W #Bottom
%patch $6797 $001AW #Bottommost
%patch $67BF $0018W #Side 1
%patch $67D9 $0018W #Side 2
%patch $67F7 $0018W #Side 3
%patch $6815 $0018W #Side 4

#Remove blanking rectangle and replace with code (Reset all stats)
%patch $6829 $B8 $0030W  $50 $33 $C0 $50 $B8 $7A1EW  $50 $9A $00001D25RL
             $83 $C4 $06 $C7 $06 $7A2AW  $000AW  $A1 $7A54W  $A3 $7A50W  $A1
             $7A56W  $A3 $7A52W  $E9 $00DDW


#################################
#Tiles				#
#################################

#What picks between normal and ghost interaction (When dead or ghosting)
%patch $8FBC $7A28W $00 $75  #74

#'Ghost mode tile interaction (Mostly empty)

#Change map tile interaction code to Status Window location
%patch $8FC6 $06BD0FA8RL

#Decrement variables sub - called by both tile codes =$037D0526RL
%patch $3CE5 $90 $90
%patch $3CF6 $55 $8B $EC $56 $8B $76 $06 $83 $3E $7A2CW  $00 $76 $04 $FF $0E #Pushbutton
             $7A2CW  $83 $3E $7A30W  $00 $76 $04 $FF $0E $7A30W  $83 $3E     #Trapbutton
         $7A3CW  $00 $76 $04 $FF $0E $7A3CW #Ontrap\floor
  $5E $5D $CB

#Normal tile collision in $6BD0 segment =$06BD0FA3RL
%patch $7B78 $55 $8B $EC $83 $EC $0C $56 $57 $8B $76 $06 $8B $44 $0A $A3 $1427W #Store position
                 $8B $44 $0C $A3 $142AW  $9A $037D0526RL     $8B $5C $2E $D1 $E3 $8B $87 $25
             $C9 $D1 $E8 $D1 $E0 $8B $16 $E9 $A7 $8B $5C $2C $D1 $E3 $03 $C3
             $89 $56 $FC $89 $46 $FA $8B $44 $30 $2B $44 $2C $40 $8B $16 $E4
             $A7 $2B $D0 $89 $56 $F8 $8B $44 $2E $89 $46 $FE $E9 $00FEW  $8B
             $7C $2C $E9 $00E5W  $C4 $5E $FA $26 $8B $1F $8E $06 $A1 $26C8W
             $8A $87 $A6 $44 $B4 $00 $25 $7F $00 $89 $46 $F6 $0B $C0 $75 $03
             $E9 $00C2W  $8B $5E $F6 $83 $EB $01 $83 $FB $2D $76 $03 $E9 $00B4W #Types
                 $D1 $E3 $2E $FF $A7 $14C1W  $C7 $06 $7A28W  $0002W  $9A
         $0B8013E9RL     $E9 $009FW  $83 $3E $7A24W  $00 $75 $06 $B8 $0007W
             $E9 $0085W  $FF $76 $FE $57 $9A $0B80183FRL     $83 $C4 $04 $E9 $0083W

#Lock, sticky, noKeen, fakeWall code (Block Keen/raindrop coding)
%patch $7C2E                                                 $8B $5E $F6 $83
             $EB $07 $D1 $E3 $83 $BF $7A60W  $00 $75 $2F $B8 $000EW  $50 $9A
             $187409F1RL     $83 $C4 $02 $8B $44 $12 $F7 $D8 $A3 $C923W  $8B
             $44 $14 $F7 $D8 $A3 $C921W  $33 $C0 $89 $44 $10 $89 $44 $0E $56
             $9A $09DC06A5RL     $83 $C4 $02 $EB $45 $8B $5E $F6 $83 $EB $07 #Door snd +1
             $D1 $E3 $FF $8F $7A60W  $FF $06 $7A2AW  $EB $A1

#Cube socket (Check c=0: NoK\500pts) Exit (TransK)
%patch $7C7E                                                 $83 $3E $7A24W
             $00 $75 $B8 $83 $06 $7A2AW  $02 $EB $93 $83 $06 $7A2AW  $06 $EB #Sock +2, Block +6
             $8C $C7 $44 $1C $0CD4W  $FF $06 $7A28W  $EB $36

#Items and main end
%patch $7C9E $8B $46 $F6 $2D $0011W  $50 $FF $76 $FE $57 $9A $0B801775RL
                     $83 $C4 $06 $47 $83 $46 $FA $02 $39 $7C $30 $72 $03 $E9
             $FF13W  $FF $46 $FE $8B $46 $F8 $D1 $E0 $01 $46 $FA $8B $44 $32
             $3B $46 $FE $72 $03 $E9 $FEF7W  $5F $5E $8B $E5 $5D $CB

#Ultrakey and multikey, multicube, allcube (Add 1\99 to ALL keys)
%patch $7CDA $A1 $00BCW  $A3 $7A66W  $EB $03 $A1 $00BEW  $A3 $7A60W  $A3 $7A62W
                 $A3 $7A64W  $B8 $0003W  $EB $B1 $83 $3E $7A24W  $0A $73 $06
             $C7 $06 $7A24W  $000AW  $83 $06 $7A24W  $F7 $E9 $FF17W

#Timer +-10 and timer stop (No add if notimer) Sound -7(3)
%patch $7D08 $83 $06 $7A22W  $0A $EB $23 $83 $06 $7A22W  $32 $EB $1C $83 $3E #+10, 50 clocks
             $7A22W  $0A $72 $07 $83 $06 $7A22W  $F6 $EB $0E $C7 $06 $7A22W  #If t<10,->0 else -10
             $0000W  $EB $06 $C7 $06 $7A28W  $0002W  $83 $06 $7A2AW  $F9 $E9 #Playstate=2, soundset
             $FEE5W

#Instexit (Change to last exit Keen seq)
%patch $7D3A $C7 $44 $1C $0E1EW  $FF $06 $7A28W  $EB $8F

#Inv-1, Inv-2, Inv-b, Inv-is (Call popup, block motion)
%patch $7D45 $FF $0E $00C0W  $83 $06 $00C0W  $2D $EB $06 $81 $06 $00C0W
         $FF7EW  $FF $76 $FE $57 $9A $06BD1F03RL     $83 $C4 $04 $E9 $FEE4W

#Teleport-blue: if we've loaded a target, teleport
%patch $7D65 $8B $5C $32 $D1 $E3 $8B $87 $25 $C9 $D1 $E8 $D1 $E0 $8B $16 $EB
             $A7 $8B $5C $2C $D1 $E3 $03 $C3 $89 $56 $FE $89 $46 $FC $C4 $5E
             $FC $26 $8B $3F $8B $C7 $25 $FF $00 $B1 $08 $D3 $E0 $05 $000FW
             $A3 $00C2W  $81 $3E $00C2W  $0400W  $76 $3C $89 $44 $0C $8B $C7
             $D3 $E8 $D3 $E0 $89 $44 $0A $C7 $44 $20 $0001W  $C7 $44 $06 $0000W
                 $8B $5C $1C $FF $77 $1C $56 $9A $09DC120ARL     $83 $C4 $04
             $C7 $44 $06 $0001W  $56 $9A $06BD18A5RL     $B8 $0007W  $50 $9A
             $187409F1RL     $83 $C4 $04 $33 $C0 $A3 $00C2W  $5F $5E $8B $E5
             $5D $CB

#Palette button- check Alt, pB and palstate, PalOn, Paloff, snd, switch
%patch $7DE7 $83 $3E $C5C5W  $00 $74 $4C $83 $3E $7A2CW  $00 $75 $45 $83 $3E
             $7A2EW  $00 $75 $0F $A0 $4E $A5 $A2 $03A6W  $8C $D8 $8E $C0 $BA
             $0396W  $EB $0D $A0 $4E $A5 $A2 $4EF7W  $8C $D8 $8E $C0 $BA $4EE7W
                 $B8 $1002W  $CD $10 $C7 $06 $C757W  $0000W  $83 $36 $7A2EW
             $01 $C7 $06 $7A2CW  $000EW  $B8 $0015W  $50 $9A $187409F1RL     
             $83 $C4 $02 $E9 $FE74W

#Bomb: Kills Keen type 10, erase tile (Tile0)
%patch $7E3D $C7 $06 $00C0W  $017FW  $FF $76 $FE $57 $9A $06BD1F03RL     $83
             $C4 $04 $C7 $06 $7A28W  $0009W  $C7 $44 $1C $101CW  $E9 $FDADW

#Trap button: Set trapvar if alt, no pB (Goes to pB, sound)
%patch $7E5D $83 $3E $C5C5W  $00 $74 $D6 $83 $3E $7A2CW  $00 $75 $CF $C7 $06
             $7A30W  $001EW  $EB $B5

#Trap: Hold Keen if no trapvar; set onfloor to trap him
%patch $7E73 $83 $3E $7A30W  $00 $75 $03 $83 $3E $7A3CW  $04 $72 $03 $E9 $FDC5W
             $83 $06 $7A3CW  $02 $E9 $FE25W

#Outfits -7A3EW -use alternate item code
%patch $7E8C $FF $06 $7A3EW  $EB $10 $FF $06 $7A40W  $EB $0A $FF $06 $7A42W
             $EB $04 $FF $06 $7A44W  $33 $C0 $50 $FF $76 $FE $57 $9A $0E8F1061RL
                     $E9 $FDFCW

#Disable space, alt mapaligns for Keen
%patch $DFC9 $C9
%patch $DFD0 $C9

#Keen detonate bomb action (For godmoded Keen) =$101CW
%patch $2FE8C $0000W $0000W $0000W $0000W $0000W $0004W $0000W $0000W
              $0B8000B0RL   $00000000L    $09DC176ERL   $15A0W

#New palette to make lg glow =$0396W
%patch $2F206 $00 $00 $00 $00 $00 $00 $00 $18  $00 $01 $1F $03 $04 $05 $06 $07  $00

#Popup tile sub =$06BD1F03RL +25pts, call tile $116 if no popsnd
%patch $8AD3 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3E $788EW  $0F
             $74 $21 $B8 $0001W  $50 $50 $57 $56 $50 $1E $B8 $00C0W  $50 $9A
             $16540F28RL     $83 $C4 $0E $B8 $000FW  $50 $9A $187409F1RL
             $83 $C4 $02 $C7 $06 $00C0W  $0116W  $5F $5E $5D $CB

#Variables for loading keys (126,1) =$00BCW
%patch $2EF2C $007EW #Superkey
              $0001W #Multikey
              $0116W #Popup walltile
              $0000W #Teleport check

#Tile property references (Relocated to new segment.) -ch 7c75
%patch $8091 $10AEW #Cube socket (At $7C7E)
             $10C3W #Exit (At $7C93)
             $1034W #Deadly (At $7C04)
             $1042W #cube: Vanish2, add -1 cubes or 500pts (At $7C12)
             $1079W #Sticky (At $7C49)
             $106DW #Keen blocking (At $7C3D)
             $105EW #Red holder (At $7C2E)
             $105EW #Yellow holder (At $7C2E)
             $105EW #Blue holder (At $7C2E)
             $105EW #Green holder (At $7C2E)
             $10BCW #Fake wall: sound then vanish (At $7C8C)
             $1112W #Multikey: Set all keys=1 (At $7CE2)
             $110AW #Superkey: set all keys =127 (At $7CDA)
             $1123W #Multicube: cubes -10 (At $7CF3)
             $112AW #Supercube: cubes=0 (At $7CFA)
             $1138W #Timer +10 (At $7D08)
             $10CEW #Red gem: vanish1 (At $7C94)
             $10CEW #Yellow gem: vanish1 (At $7C9E)
             $10CEW #Ble gem: vanish1 (At $7C9E)
             $10CEW #Green gem: vanish1 (At $7C9E)
             $10CEW #100 points: vanish1 (At $7C9E)
             $10CEW #200 points: vanish1 (At $7C9E)
             $10CEW #500 points: vanish1 (At $7C9E)
             $10CEW #1000 points: vanish1 (At $7C9E)
             $10CEW #2000 points: vanish1 (At $7C9E)
             $10CEW #5000 points: vanish1 (At $7C9E)
             $10CEW #1UP: vanish1 (At $7C9E)
             $10CEW #Stunner tile: vanish1 (At $7C9E)
             $115CW #Timer stop: Remove timer counter (At $7D2C)
             $1146W #Timer -10 (At $7D16)
             $116AW #Instexit (At $7D3A)
             $1186W #InVisible (At $7D56)
             $1179W #InVisione (At $7D49)
             $1175W #InVisitwo (At $7D45)
             $1180W #InVisiblue (At $7D50)
             $113FW #Superclock (At $7D0F)
             $1195W #Teleport (At $7D65)
             $1217W #Lightbutton (At $7DE7)
             $10E1W #Gravel(At $7CB1)
             $126DW #Bomb (At $7E3D)
             $128DW #Trap button (At $7E5D)
             $12CEW #Ice boot (At $7E9E)
             $12CEW #Fire boot (At $7E8C)
             $12CEW #Force boot (At $7E8C)
             $12CEW #Flippers (At $7E8C)
             $10CEW #Force down (At $7C9E)
             $10CEW #Force up (At $7C9E)
             $10CEW #Force left (At $7C9E)
             $10CEW #Force right (At $7C9E)


#################################
#Items				#
#################################

#List of item sounds:
#0A-cube 0B-door 0C-socket 0F-fake 03-timer 02-supertimer 22-boots

#Drop code now a second item seg, no 1UP but 50pt tiles
%patch $D05F $57 $56 $9A $0FA8020CRL     $83 $C4 $04 $83 $3E $7A2AW  $0A $75 #If not E, jump
             $5A $FF $0E $7A24W  $83 $3E $7A24W  $00 $75 $4F $C7 $06 $7A2AW  #If not 0 cube, jump
             $0011W  $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E #Set sound=11
             $D8 $A7 $C7 $07 $0001W  $8B $C6 $B1 $08 $D3 $E0 $89 $47 $0A $8B #Spawn 1UP
             $C7 $48 $D3 $E0 $89 $47 $0C $C7 $47 $10 $FFFFW  $B8 $00DAW  $89
             $47 $1E $89 $47 $40 $B8 $1F28W  $50 $53 $9A $09DC118CRL     $83
             $C4 $04 $8B $1E $D8 $A7 $C7 $47 $06 $0000W  $A1 $7A2AW  $50 $9A #Load\play sound
             $187409F1RL     $B8 $0032W  $50 $9A $06BD1EF2RL     $83 $C4 $04 #Add 50pts
             $C7 $06 $7A2AW  $000AW  $5F $5E $5D $CB			    #Reset sound

#Compress Keen's sprite interaction to only work with items; change ammo to cube
%patch $CCA9 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $8B $04 $3D $0004W  $72 #<4-nil, >4-enemy, 4-item
             $79 $77 $7B $8B $5C
             $3E $D1 $E3 $FF $B7 $13DCW  $9A $187409F1RL     $83 $C4 $02 $C7
             $04 $0001W  $C7 $44 $20 $0003W  $8B $5C $3E $D1 $E3 $8B $87 $140CW
                 $89 $44 $1E $8B $5C $3E $D1 $E3 $FF $B7 $13F4W  $9A $06BD1EF2RL
                 $83 $C4 $02 $83 $7C $3E $04 $7D $0B $8B $5C $3E $D1 $E3
             $FF $87 $7A60W  $EB $22 $83 $7C $3E $0A $75 $06 $FF $06 $7A6AW
             $EB $16 $83 $7C $3E $0B $75 $10 $83 $3E $7A24W  $00 $74 $04 $FF
             $0E $7A24W  $B8 $1F46W  $EB $03 $B8 $1F28W  $50 $56 $9A $09DC120ARL
                     $83 $C4 $04 $5F $5E $5D $CB

#Other sprite type: Convert Keen into negative Keen (He bounces away)
%patch $CD38 $B8 $000FW  $50 $9A $187409F1RL     $83 $C4 $02 $C7 $45 $1C $0A22W
                 $83 $06 $7A2CW  $08 $83 $3E $7A2CW  $18 $72 $0B $C7 $06 $7A28W #If stuck, kill
             $0006W  $9A $0B8013E9RL     $5F $5E $5D $CB

#Negative Keen action 
%patch $2F892 $0000W $0000W $0001W $0001W $0000W $0004W $FFD8W $FFD8W #Bumped Keen
              $0D8F06F0RL   $00000000L    $09DC176ERL   $0A40W
%patch $2F8B0 $0000W $0000W $0001W $0001W $0000W $000FW $0000W $0000W #Blocked Keen
              $00000000L    $00000000L    $09DC176ERL   $15A0W

#Change ammo sound to splash
%patch $30262 $000AW

#Ammo worth 50pts
%patch $3027A $0032W

#Gems are +100 pts
%patch $30264 $0064W #Red gem
              $0064W #Yellow gem
              $0064W #Blue gem
              $0064W #Green gem

#Move items init offsets
%patch $ED94 $8B $46 $F8 $05 $FFF5W

#Move item inits
%patch $EE99 $04A4W #Red Gem (At $ED94)
%patch $EE9B $04A4W #Yellow Gem (At $ED94)
%patch $EE9D $04A4W #Blue Gem (At $ED94)
%patch $EE9F $04A4W #Green Gem (At $ED94)
%patch $EEA1 $04A4W #100 Pts (At $ED94)
%patch $EEA3 $04A4W #200 pts (At $ED94)
%patch $EEA5 $04A4W #500 Pts (At $ED94)
%patch $EEA7 $04A4W #1000 Pts (At $ED94)
%patch $EEA9 $04A4W #2000 Pts (At $ED94)
%patch $EEAB $04A4W #5000 Pts (At $ED94)
%patch $EEAD $04A4W #Bomb (At $ED94)
%patch $EEAF $04A4W #Cube (At $ED94)

#Increase dropsplash to seven actions
%patch $30DC0 $0006W
%patch $30DDE $0006W
%patch $30DFC $0006W
%patch $30E0E $0A5EW
%patch $2F8CE $00D6W $00D6W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0A7CW
%patch $2F8EC $00D5W $00D5W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0A9AW
%patch $2F90A $00D4W $00D4W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0AB8W
%patch $2F928 $00D3W $00D3W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0000W

#Alternate item code for boots =$0E8F1061RL
%patch $F951 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $0A $B8 $0001W  $50 $50
             $FF $76 $08 $57 $50 $1E $B8 $1424W  $50 $9A $16540F28RL     $83
             $C4 $0E $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0001W  $C7 $47 $20 $0003W  $8B $C7 $B1 $08 $D3
             $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89 $47 $0C $C7 $47 $10 $FFFFW
                 $B8 $00E1W  $8B $1E $D8 $A7 $89 $47 $1E $89 $47 $40
             $B8 $1F28W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $8B $1E $D8
             $A7 $C7 $47 $06 $0000W  $B8 $00FAW  $50 $9A $06BD1EF2RL     $B8 #250pts
             $0022W  $50 $9A $187409F1RL     $83 $C4 $04 $5F $5E $5D $CB


#################################
#Keen				#
#################################

#Change map Keen's cache to hold extra stuff we need
%patch $306E4 $00BDW #Map Keen Cache start
%patch $3072E $0142W #Map Keen cache end

#Three different keen starts (Plus universal Keen!) -pointers
%patch $EE85 $00A2W #Easy Keen (At $E993)
%patch $EE87 $00ACW #Medium Keen (At $E99C)
%patch $EE8B $00B5W #Hard Keen (At $E9A5)

#Inits (Check difficulty, proceed to mapk if equal.)
%patch $E993 $83 $3E $7A6CW  $01 $75 $3C $EB $10 #Easy
%patch $E99C $83 $3E $7A6CW  $02 $75 $33 $EB $07 #Medium
%patch $E9A5 $83 $3E $7A6CW  $03 $75 $2A	 #Hard

#Map Keen also spawns the time counter IF time isn't 0
%patch $E9C3 $83 $3E $7A22W  $00 $74 $0C $FF $76 $FC $57 $9A $0B80000ERL
             $83 $C4 $04 $E9 $0424W

#Map Keen spawn, if deathcount <0 spawn special, if >20 do levhint Keen
%patch $DDFA $55 $8B $EC $8B $1E $D6 $A7 $C7 $07 $0002W  $8B $46 $06 $B1 $08
             $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89 $47 $0C $8B $1E $D6
             $A7 $C7 $47 $02 $0002W  $C7 $47 $20 $0001W  $C7 $47 $0E $0000W 
             $C7 $47 $10 $0000W  $C7 $47 $3E $0006W  $C7 $47 $40 $0003W  $C7
             $47 $42 $0000W  $C7 $47 $1E $0109W  $83 $3E $7A5CW  $14 $74 $11
             $83 $3E $7A5CW  $00 $75 $05 $B8 $1076W  $EB $08 $B8 $14ECW  $EB
             $03 $B8 $1148W  $50 $53 $9A $09DC118CRL     $83
             $C4 $04 $5D $CB

#Keen's first level entrance action (Spawn flash) =$1076W
%patch $2FEE6 $0000W $0000W $0000W $0000W $0000W $0001W $0000W $0000W
              $0B8000FBRL   $00000000L    $09DC176ERL   $14ECW

#Keen's 20th level entrance action (Fail window) =$1148W
%patch $2FFB8 $0000W $0000W $0000W $0000W $0000W $0008W $0000W $0000W
              $0D8F060BRL   $00000000L    $09DC176ERL   $14ECW

#Spawn flash behavior =$0B8000FBRL
%patch $B8FB $55 $8B $EC $56 $8B $76 $06 $B8 $0001W  $50 $9A $06BD1E11RL
             $83 $C4 $02 $8B $1E $D8 $A7 $C7 $07 $0001W  $C7 $47 $20 $0003W
             $8B $44 $0A $89 $47 $0A $8B $44 $28 $2D $00F0W  $89 $47 $0C $B8
             $1094W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5E $5D $CB

#Flash go backgnd behavior =$0B80013ARL
%patch $B93A $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $44 $20 $0001W  $5E $5D $CB

#Keen bring up failure window =$0D8F060BRL
%patch $DEFB $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $000EW  $50 $9A
         $187409F1RL     $83 $C4 $02 $9A $0E8F0A66RL     $9A $16540D59RL     $5E $5D $CB

#Flash sequence =$1094W
%patch $2FF04 $00BDW $00BDW $0000W $0000W $0000W $0008W $0000W $0000W #Play Linsnd
              $0B80024CRL   $00000000L    $09DC176ERL   $10B2W
%patch $2FF22 $00BEW $00BEW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $10D0W
%patch $2FF40 $00BFW $00BFW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $10EEW
%patch $2FF5E $00C0W $00C0W $0000W $0000W $0000W $0008W $0000W $0000W #Go behind Keen
              $0B80013ARL   $00000000L    $09DC176ERL   $110CW
%patch $2FF7C $00C1W $00C1W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $112AW
%patch $2FF9A $00C2W $00C2W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0000W

#Flash soundplay is Lindsnd
%patch $BA54 $2D

#'Can't swim' windo variables
%patch $F364 $000BW #Cache Keen's bitmap
%patch $F380 $000BW #Display Keen's bitmap
%patch $F370 $0008W #Window height
%patch $F374 $001DW #Window width
%patch $F3A5 $1C70W #Text read from
%patch $F3A3 $02

#Text
%patch $30AE0 "You seem to be having some" $0A
              "problems with this level." $0A
              "You can now skip to the" $0A
              "next level by pressing '+'" $0A
              "during gameplay. (This will" $0A
              "also clear your score.)" $00

#Keen can collect item spritess on map (Also ticks Keen variables)
%patch $30370 $0B8014A9RL #Waiting
%patch $30424 $0B8014A9RL #Walking
%patch $30380 $0B8014A9RL #Waving
%patch $3039E $0B8014A9RL #Waving
%patch $303BC $0B8014A9RL #Waving
%patch $303DA $0B8014A9RL #Waving
%patch $303F8 $0B8014A9RL #Waving

#upKeen sequence, mostly animating falling down a hole =$0CD4W
%patch $2FB44 $0105W $0105W $0000W $0000W $0000W $000DW $0000W $0000W #Clear level of threats, timer
              $0FA80103RL   $00000000L    $09DC176ERL   $0D2EW
%patch $2FB9E $013DW $013DW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D4CW
%patch $2FBBC $0142W $0142W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D6AW
%patch $2FBDA $013EW $013EW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D88W
%patch $2FBF8 $013FW $013FW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0DA6W
%patch $2FC16 $0140W $0140W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0DC4W
%patch $2FC34 $0141W $0141W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0E00W
%patch $2FC70 $FFFFW $FFFFW $0000W $0000W $0000W $0010W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0E1EW
%patch $2FC8E $FFFFW $FFFFW $0000W $0000W $0000W $000DW $0000W $0000W #Vanish, winlev
              $0FA80130RL   $00000000L    $09DC176ERL   $0E00W

#Winning behavior 1: clear all sprites inc counter from level =$0FA80103RL
%patch $FB83 $55 $8B $EC $56 $57 $8B $76 $06 $8B $5E $08 $8B $1E $D6 $A7 $8B 
             $7F $48 $EB $11 $83 $3D $02 $76 $09 $57 $9A $06BD1E8BRL     $83 
             $C4 $02 $8B $7D $48 $0B $FF $75 $EB $5F $5E $5D $CB

#Winning behavior 2: add bonuses to score $0FA80130RL
%patch $FBB0 $55 $8B $EC $56 $57 $8B $7E $06 $C7 $06 $7A70W  $0002W  #Set state=win
             $83 $3E $7A5CW  $0A $73 $2F $A1 $7A68W  $A3 $1427W  $B8 #Deathcheck, Copy deathcount
             $03E8W  $83 $3E $7A5CW  $00 $74 $09 $2D $0064W  $FF $0E #Deaths dec levbonus
             $7A5CW  $EB $F0 $50 $83 $3E $1427W  $00 $74 $0B $FF $0E #Add bonus once per lev
             $1427W  $9A $06BD1EF2RL     $EB $EE $C7 $06 $7A5CW      #Clear deathcount
         $0000W  $83 $3E $7A6CW  $02 $72 $07 $77 $0A $B8 $0032W  $EB #Load time bonus on difficulty
             $08 $B8 $000AW  $EB $03 $B8 $0064W  $50 $83 $3E $7A22W  #Check time
             $00 $74 $0B $FF $0E $7A22W  $9A $06BD1EF2RL     $EB $EE #Add time bonus,codefit jump
             $5F $EB $63

#Bomb detonation sequence (Deaths, exploding bombs) =$1756W
%patch $305C6 $011AW $011AW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $1774W
%patch $305E4 $011BW $011BW $0000W $0000W $0000W $0008W $0000W $0000W #Reset type to harmless
              $0FA80269RL   $09DC1752RL   $09DC176ERL   $1792W
%patch $30602 $011CW $011CW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17B0W
%patch $30620 $011DW $011DW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17CEW
%patch $3063E $011EW $011EW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17ECW
%patch $3065C $011FW $011FW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $0000W

#Keen's adjust location code (First sue of PushButton!)
%patch $DF1E $55 $8B $EC $33 $C0 $83 $3E $7A2CW  $00 $75 $3E $83 $3E $1426W
             $00 $7D $04 $FF $06 $1428W  $A3 $1426W  $83 $3E $1429W  $00 $7D
             $04 $FF $06 $142BW  $A3 $1429W  $A1 $1427W  $89 $44 $0A $A1 $142AW
                 $89 $44 $0C $C7 $47 $1C $1582W  $B8 $001BW  $50 $9A $187409F1RL
                     $83 $C4 $02 $83 $06 $7A2CW  $10 $5D $CB

#Keen's resetting action (Bored) =$1582W
%patch $30F22 $0000W $0000W $0003W $0000W $0000W $001EW $0000W $0000W
              $0D8F06F0RL   $00000000L    $09DC176ERL   $14ECW

#Rejig Keen's death code for multideaths
%patch $CBE9  $55 $8B $EC $83 $3E $C5D1W  $00 $75 $0D $83 $3E $C629W  $00 $74 #Check loop, god
              $08 $C7 $06 $7A28W  $0000W  $5D $CB $A1 $7A28W  $A3 $1429W  $B8 #If god, blank deathvar
              $0A9AW  $A3 $1427W  $83 $3E $1429W  $00 $74 $0B $83 $06 $1427W  #Inc deathact using deathvar2
              $1E $FF $0E $1429W  $EB $EE $A1 $1427W  $50 $C7 $06 $C5D1W      #Load act, playtimer
          $001EW  $C7 $06 $A7DAW  $0001W  $C7 $47 $06 $0000W  $FF $36 $D6 $A7 #Clipping, doact
              $9A $09DC120ARL     $83 $C4 $04 $B8 $0017W  $50 $9A $187409F1RL #Sound
                  $83 $C4 $02 $FF $06 $7A28W  $C7 $07 $0001W   $5D $CB        #Inc deathcount, deathvar

#Death actions
%patch $2F946 $00CEW $00CEW $0001W $0000W $0000W $0006W $0010W $0010W #Slime = $0AB6W
              $00000000L    $00000000L    $09DC176ERL   $0E3CW
%patch $2F964 $0118W $0118W $0000W $0000W $0000W $0004W $0000W $0000W #Suicide = $0AD4W
              $0B8000B0RL   $00000000L    $09DC176ERL   $0D10W
%patch $2F982 $0118W $0118W $0000W $0000W $0000W $0004W $0000W $0000W #Timeout = $0AF2W
              $00000000L    $00000000L    $09DC176ERL   $0D10W
%patch $2F9A0 $0118W $0118W $0000W $0000W $0000W $0004W $0000W $0000W #Enemy = $0B10W
              $00000000L    $00000000L    $09DC176ERL   $0D10W
%patch $2F9BE $0118W $0118W $0000W $0000W $0000W $0004W $0000W $0000W #Moveblock = $0B2EW
              $00000000L    $00000000L    $09DC176ERL   $0D10W
%patch $2F9DC $0118W $0118W $0001W $0000W $0000W $0006W $0010W $0010W #Fire = $0B4CW
              $0B8000B0RL   $00000000L    $09DC176ERL   $0F2CW
%patch $2F9FA $00CEW $00CEW $0001W $0000W $0000W $0006W $0010W $0010W #Water = $0B6AW
              $00000000L    $00000000L    $09DC176ERL   $0EB4W
%patch $2FA18 $0118W $0118W $0000W $0000W $0000W $000CW $0000W $0000W #Bomb = $0B88W
              $0B8000B0RL   $00000000L    $09DC176ERL   $0FA4W

#Slime splash sequence =$0E3CW
%patch $2FCAC $00CAW $00CAW $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0E5AW
%patch $2FCCA $00CBW $00CBW $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0E78W
%patch $2FCE8 $00CCW $00CCW $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0E96W
%patch $2FD06 $00CDW $00CDW $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D10W

#Splash death sequence =$0EB4W
%patch $2FD24 $00CFW $00CFW $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0ED2W
%patch $2FD42 $00D0W $00D0W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0EF0W
%patch $2FD60 $00D1W $00D1W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0F0EW
%patch $2FD7E $00D2W $00D2W $0000W $0000W $0000W $0006W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D10W

#Burn death sequence =$0F2CW
%patch $2FD9C $0119W $0119W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0F4AW
%patch $2FDBA $00C9W $00C9W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0F68W
%patch $2FDD8 $00C8W $00C8W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0F86W
%patch $2FDF6 $00C7W $00C7W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D10W

#Exploded death sequence =$0FA4W
%patch $2FE14 $00C6W $00C6W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0FC2W
%patch $2FE32 $00C5W $00C5W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0FE0W
%patch $2FE50 $00C4W $00C4W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0FFEW
%patch $2FE6E $00C3W $00C3W $0000W $0000W $0000W $000CW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D10W

#Fail level dead Keen (Frame 2, no anim change) =$0D10W
%patch $2FB80 $0000W $0000W $0000W $0000W $0000W $0006W $0000W $0000W 
              $0B8000A0RL   $00000000L    $09DC176ERL   $0D10W

#Fail level behavior =$0B8000A0RL
%patch $B8A0 $55 $8B $EC $56 $8B $76 $06 $C7 $06 $7A70W  $0001W  $5E $5D $CB

#Spawn explosion behavior =$0B8000B0RL
%patch $B8B0 $55 $8B $EC $56 $8B $76 $06 $B8 $0001W  $50 $9A $06BD1E11RL
             $83 $C4 $02 $8B $1E $D8 $A7 $C7 $07 $0001W  $C7 $47 $20 $0003W
             $8B $44 $0A $89 $47 $0A $8B $44 $28 $2D $0080W  $89 $47 $0C $B8
             $1756W $50 $53 $9A $09DC118CRL      $83 $C4 $04 $B8 $0019W  $50
             $9A $187409F1RL     $83 $C4 $02 $5E $5D $CB


#################################
#GLOBAL ENEMY CODE		#
#################################

#Inits are $EE83 + 2n

#Split inits into EMH segments (NEH) -$30\$1B ->$4B, $7B, $AB
%patch $E945 $83 $3E $7A6CW  $02 $72 $09 $77 $0E $83 $FB $4B $73 $16 $EB $0D
             $83 $FB $7B $73 $0F $EB $06 $81 $FB $00ABW  $73 $07 $D1 $E3 $2E
             $FF $A7 $0595W  $E9 $0491W

#Correct position behavior: if a sprite is not on tile bounday, fix this =$0FA802FDRL
%patch $FD7D $55 $8B $EC $8B $44 $0A $A3 $1431W  $8B $44 $0C $A3 $1434W  $33 $C0 $83 $3E $1430W
             $00 $7D $04 $FF $06 $1432W  $A3 $1430W  $83 $3E $1433W  $00 $7D
             $04 $FF $06 $1435W  $A3 $1433W  $A1 $1431W  $89 $44 $0A $A1 $1434W
                 $89 $44 $0C $5D $CB

#Enemy position buffer
%patch $302A0 $0000W $0000W $0000W $0000W

#Enemy sprite collision =$0B80155ERL NEEDS KILLTYPE~!
%patch $CD64 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $8B $1D $83 $EB $01
             $83 $FB $0B $77 $69 $D1 $E3 $2E $FF $A7 $16B5W  $C7 $06 $7A28W #Kill Keen
             $0005W  $9A $0B8013E9RL     $5F $5E $5D $CB

#Destroy sprite (Type 3 interaction; sound, expact, 10K)
%patch $CD8F $B8 $1756W  $50 $56 $9A $09DC120ARL     $83 $C4 $04 $B8 $0019W
             $50 $9A $187409F1RL     $83 $C4 $02 $B8 $2710W  $50 $9A $06BD1EF2RL
                     $83 $C4 $02 $5F $5E $5D $CB

#Item: (Type 4 interaction; destroy item)
%patch $CDB8 $57 $9A $0D8F0D43RL     $83 $C4 $02 $5F $5E $5D $CB

#Another enemy: block movement
%patch $CDC5 $C7 $44 $3E $0001W  $8B $44 $12 $F7 $D8 $A3 $C923W  $8B
             $44 $14 $F7 $D8 $A3 $C921W  $33 $C0 $89 $44 $10 $89 $44 $0E $56
             $9A $09DC06A5RL     $83 $C4 $02 $5F $5E $5D $CB

#List of sprite types enemies respond to
%patch $CEB5 $158BW #Nothing (At $CD8B)
%patch $CEB7 $1580W #Keen: Kill Keen (At $CD80)
%patch $CEB9 $158FW #Bomb: Destroy sprite (At $CD8F)
%patch $CEBB $15B8W #Item: destroyed (At $CDB8)
%patch $CEBD $15C5W #Enemy (At $CEC5)
%patch $CEBF $1557W #Kill Keen (At $CE79)
%patch $CEC1 $1557W #Get knocked off of pole by Bounder (At $CE81)
%patch $CEC3 $1557W #Nothing (At $CEB0)
%patch $CEC5 $1557W #Nothing (At $CEB0)
%patch $CEC7 $1557W #Nothing (At $CEB0)
%patch $CEC9 $1557W #Nothing (At $CEB0)
%patch $CECB $1557W #Get knocked off pole by Platform (At $CE4E)

#Block shots code spawns smashed items
%patch $E63F  $09AAW

#Smashed items sequence =$09AAW
%patch $2F81A $0084W $0084W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $09C8W
%patch $2F838 $0085W $0085W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $09E6W
%patch $2F856 $0086W $0086W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0A04W
%patch $2F874 $0087W $0087W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0000W

#Enemy tile collision in $B800 segment =$0B800FA3RL
%patch $C7A3 $55 $8B $EC $83 $EC $0C $56 $57 $8B $76 $06 $8B $5C $2E $D1 $E3 $8B $87 $25
             $C9 $D1 $E8 $D1 $E0 $8B $16 $E9 $A7 $8B $5C $2C $D1 $E3 $03 $C3
             $89 $56 $FC $89 $46 $FA $8B $44 $30 $2B $44 $2C $40 $8B $16 $E4
             $A7 $2B $D0 $89 $56 $F8 $8B $44 $2E $89 $46 $FE $EB $47 $8B
             $7C $2C $EB $32 $C4 $5E $FA $26 $8B $1F $8E $06 $A1 $26C8W
             $8A $87 $A6 $44 $B4 $00 $25 $7F $00 $89 $46 $F6 $0B $C0 $74 $12
             $8B $5E $F6 $83 $EB $01 $83 $FB $28 $77 $07 			#Types
                 $D1 $E3 $2E $FF $A7 $0F03W  $47 $83 $46 $FA $02 $39 $7C $30
             $73 $C9 $FF $46 $FE $8B $46 $F8 $D1 $E0 $01 $46 $FA
             $8B $44 $32 $3B $46 $FE $73 $B1 $5F $5E $8B $E5 $5D $CB

#Destroy tile (Massive code chain starts here)
%patch $C839 $FF $76 $FE $57 $9A $0B800EC9RL     $83 $C4 $04 $EB $CF

#Block enemy (Set blocked var, stop movement)
%patch $C847 $C7 $44 $3E $0001W  $8B $44 $12 $F7 $D8 $A3 $C923W  $8B
             $44 $14 $F7 $D8 $A3 $C921W  $33 $C0 $89 $44 $10 $89 $44 $0E $56
             $9A $09DC06A5RL     $83 $C4 $02 $EB $A7

#Teleport (Teleports enemies without camera\limit changes)
%patch $C86F $8B $5C $32 $D1 $E3 $8B $87 $25 $C9 $D1 $E8 $D1 $E0 $8B $16 $EB
             $A7 $8B $5C $2C $D1 $E3 $03 $C3 $89 $56 $FE $89 $46 $FC $C4 $5E
             $FC $26 $8B $3F $8B $C7 $25 $FF $00 $B1 $08 $D3 $E0 $05 $000FW
             $A3 $00E6W  $81 $3E $00E6W  $0400W  $76 $36 $89 $44 $0C $8B $C7
             $D3 $E8 $D3 $E0 $89 $44 $0A $C7 $44 $20 $0001W  $C7 $44 $06 $0000W
                 $8B $5C $1C $FF $77 $1C $56 $9A $09DC120ARL     $83 $C4 $04
             $C7 $44 $06 $0001W  $B8 $0007W  $50 $9A $187409F1RL     $83 $C4
             $02 $33 $C0 $A3 $00E6W  $5F $5E $8B $E5 $5D $CB

#Bomb (Destroys enemy in explosion)
%patch $C8EB $C7 $06 $00C0W  $017FW  $FF $76 $FE $57 $9A $06BD1F03RL     $83
             $C4 $04 $C7 $44 $1C $103AW  $EB $E1

#Trap button: Destroy but set trapvar first
%patch $C904 $C7 $06 $7A30W  $001EW  $E9 $FF2CW


#Bombed enemy sequence =$103AW
%patch $2FEAA $0088W $0088W $0000W $0000W $0000W $000CW $0000W $0000W
              $0B8000B0RL   $00000000L    $09DC176ERL   $1058W
%patch $2FEC8 $0089W $0089W $0000W $0000W $0000W $000CW $0000W $0000W
              $0B8000B0RL   $00000000L    $09DC176ERL   $0000W

#Enemy temp vars
%patch $2EF56 $0000W #Teleport check
%patch $2EF58 $0094W #Chaser anim cache

#Enemy tile pointers
%patch $C703 $1047W #Cube socket (Blocked)
             $1016W #Exit (Ignore)
             $1016W #Deadly (Ignore)
             $1039W #cube: (Destroy)
             $1016W #Sticky (Ignore)
             $1016W #Keen blocking (Ignore)
             $1047W #Red holder (Blocked)
             $1047W #Yellow holder (Blocked)
             $1047W #Blue holder (Blocked)
             $1047W #Green holder (Blocked)
             $1047W #Fake wall: sound then vanish (Blocked)
             $1039W #Multikey: (Destroy)
             $1039W #Superkey: (Destroy)
             $1039W #Multicube: (Destroy)
             $1039W #Supercube: (Destroy)
             $1039W #Timer +10 (Destroy)
             $1039W #Red gem: (Destroy)
             $1039W #Yellow gem: (Destroy)
             $1039W #Ble gem: (Destroy)
             $1039W #Green gem: (Destroy)
             $1039W #100 points: (Destroy)
             $1039W #200 points: (Destroy)
             $1039W #500 points: (Destroy)
             $1039W #1000 points: (Destroy)
             $1039W #2000 points: (Destroy)
             $1039W #5000 points: (Destroy)
             $1039W #1UP: vanish1 (Destroy)
             $1039W #Stunner tile: (Destroy)
             $1039W #Timer stop: (Destroy)
             $1039W #Timer -10 (Destroy)
             $1039W #Instexit (Destroy)
             $1047W #InVisible (Blocked)
             $1047W #InVisione (Blocked)
             $1047W #InVisitwo (Blocked)
             $1047W #InVisiblue (Blocked)
             $1039W #Superclock (Destroy)
             $106FW #Teleport (Teleport enemy)
             $1039W #Lightbutton (Destroy)
             $1047W #Gravel (Blocked)
             $10EBW #Bomb (Bomb)
             $1104W #Trapbutton (Destroy with push)
             $1016W #Force down (At $7C9E)
             $1016W #Force up (At $7C9E)
             $1016W #Force left (At $7C9E)
             $1016W #Force right (At $7C9E)

#Enemy tile destruction code=$0B800EC9RL
%patch $C6C9 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $B8 $0001W  $50 $50
             $57 $56 $50 $1E $B8 $1424W  $50 $9A $16540F28RL     $83 $C4 $0E
             $B8 $0019W  $50 $9A $187409F1RL     $83 $C4 $02 $57 $56 $9A
         $0B800E87RL     $83 $C4 $04 $5F $5E $5D $CB

#Enemy tile destruction fizz spawn =$0B800E87RL
%patch $C687 $55 $8B $EC $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
             $1E $D8 $A7 $C7 $47 $06 $0000W  $C7 $47 $20 $0003W  $C7 $07 $0001W
                 $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0
             $89 $47 $0C $B8 $09AAW  $50 $53 $9A $09DC118CRL     $83 $C4 $04
             $5D $CB

#Global enemy cache
%patch $306D2 $0082W #Cache start
%patch $3071C $0098W #Cache end

#Set global cache at init ends-6
%patch $EDF7 $C7 $06 $CB3DW  $0001W


#################################
#ENEMY: Random Cube		#
#################################

#Initiations
%patch $EEC1 $00E9W #Easy random (At $EBD9)
%patch $EF21 $00E9W #Medium
%patch $EF81 $00E9W #Hard

#Initiation (Goto global cache)
%patch $E9D9 $FF $76 $FC $57 $9A $0FA80269RL     $83 $C4 $04 $E9 $040FW

#Change spawn to be simpler
%patch $FCE9 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0005W  $C7 $47 $02 $0002W  $C7 $47 $20 $0000W
             $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89
             $47 $0C $B8 $1FB8W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#Random actions, 1 chooses, 1 moves
%patch $30E28 $0083W $0083W $0000W $0000W $0000W $0020W $0000W $0000W #Decide
              $0FA802AARL   $0B801564RL   $0B800F73RL   $1FD6W
%patch $30E46 $0083W $0083W $0001W $0000W $0000W $0010W $0010W $0010W #Move
              $00000000L    $0B801564RL   $0B800F73RL   $1FF4W
%patch $30E64 $0083W $0083W $0000W $0000W $0000W $0004W $0000W $0000W #Correct 1
              $0FA802FDRL   $0B801564RL   $0B800F73RL   $1FB8W

#Random behavior: each time pick a random HV direction =$0FA802AARL
%patch $FD2A $55 $8B $EC $56 $8B $76 $06 $9A $1D02002ARL     $3D $0055W  $7D
             $07 $C7 $44 $0E $0000W  $EB $11 $3D $00AAW  $7D $07 $C7 $44 $0E
             $FFFFW  $EB $05 $C7 $44 $0E $0001W  $9A $1D02002ARL     $3D $0055W
                 $7D $07 $C7 $44 $10 $0000W  $EB $11 $3D $00AAW  $7D $07 $C7
             $44 $10 $FFFFW  $EB $05 $C7 $44 $10 $0001W  $C7 $44 $3E $0000W #Reset colvar
             $5E $5D $CB

#Random tile interaction: Access advanced tiles =$0B800F73RL-$06BD0FA2RL
%patch $C773 $55 $8B $EC $56 $8B $76 $06 $56 $9A $0B800FA3RL     $83 $C4 $02
             $FF $74 $20 $33 $C0 $50 $FF $74 $1E $FF $74 $0C $FF $74 $0A $8B
             $C6 $05 $46 $00 $50 $9A $16541641RL     $83 $C4 $0C $5E $5D $CB


#################################
#ENEMY: Chaser			#
#################################

#Initiations
%patch $EEC3 $00F8W #Easy chase (At $E9E8)
%patch $EF23 $00F8W #Medium
%patch $EF83 $00F8W #Hard

#Initiation (Goto global cache)
%patch $E9E8 $FF $76 $FC $57 $9A $0FA80338RL     $83 $C4 $04 $E9 $0400W

#Spawn =$0FA80338RL
%patch $FDB8 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0005W  $C7 $47 $02 $0002W  $C7 $47 $20 $0000W
             $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89
             $47 $0C $C7 $47 $1E $0094W  $B8 $2012W  $50 $53 $9A $09DC118CRL
                 $83 $C4 $04 $5D $CB

#Chase actions (No animations, relies on behavior to set)
%patch $30E82 $0000W $0000W $0000W $0000W $0000W $0010W $0000W $0000W #Decide
              $0FA8037ERL   $0B801564RL   $0B800F73RL   $2030W
%patch $30EA0 $0000W $0000W $0001W $0000W $0000W $0010W $0020W $0020W #Move
              $00000000L    $0B801564RL   $0B800F73RL   $204EW
%patch $30EBE $0000W $0000W $0000W $0000W $0000W $0004W $0000W $0000W #Correct 1
              $0FA802FDRL   $0B801564RL   $0B800F73RL   $2012W

#Chase behavior, set dirs and animation =$0FA8037ERL
%patch $FDFE $55 $8B $EC $56 $8B $76 $06 $B8 $0094W  $A3 $00E8W  $C7 $44 $0E
             $0000W  $C7 $44 $10 $0000W  $C7 $44 $3E $0000W  $8B $44 $0C $8B
             $1E $D6 $A7 $3B $47 $0C $77 $0E $74 $17 $C7 $44 $10 $0001W  $83
             $06 $00E8W  $03 $EB $0B $C7 $44 $10 $FFFFW  $81 $06 $00E8W  $FFFDW
                 $8B $44 $0A $8B $1E $D6 $A7 $3B $47 $0A $77 $0D $74 $14 $C7
             $44 $0E $0001W  $FF $06 $00E8W  $EB $09 $C7 $44 $0E $FFFFW  $FF
             $0E $00E8W  $A1 $00E8W  $89 $44 $1E $5E $5D $CB


#################################
#Popup wall			#
#################################

#Single EMH spawn
%patch $EEBD $0107W

#Initiation (Goto global cache)
%patch $E9F7 $FF $76 $FC $57 $9A $0FA803EARL     $83 $C4 $04 $E9 $03F1W

#Spawn =$0FA803EARL
%patch $FE6A $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0001W  $C7 $47 $02 $0002W  $C7 $47 $06 $0000W
             $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89
             $47 $0C $B8 $206CW  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#Waiting action; do nothing
%patch $30EDC $00F1W $00F1W $0000W $0000W $0000W $7530W $0000W $0000W
              $00000000L    $0FA8042BRL   $09DC176ERL   $206CW

#Sprite collision 1, change into activated, set onFloor =$0FA8042BRL
%patch $FEAB $55 $8B $EC $56 $8B $76 $06 $C7 $44 $1C $208AW  $B8 $0015W  $50
             $9A $187409F1RL     $83 $C4 $02 $EB $07

#Triggered action
%patch $30EFA $FFFFW $FFFFW $0000W $0000W $0000W $0008W $0000W $0000W
              $0FA80455RL   $0FA80445RL   $09DC176ERL   $208AW

#Sprite collision 2, set onTrap (OnFloor!) =$0FA80445RL
%patch $FEC5 $55 $8B $EC $56 $8B $76 $06 $C7 $06 $7A30W  $0004W  $5E $5D $CB

#Popup behavior: If no Onfloor goto animate =$0FA80455RL
%patch $FED5 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $83 $3E $7A30W  $00 $75
             $05 $C7 $44 $1C $20A8W  $5E $5D $CB

#Animate tile action-vanishes
%patch $30F18 $0000W $0000W $0000W $0000W $0000W $0006W $0000W $0000W
              $0FA8046ERL   $00000000L    $00000000L    $0000W

#AnimTile behavior =$0FA8046ERL
%patch $FEEE $55 $8B $EC $83 $EC $16 $56 $57 $8B $5E $06 $8B $5F $2E $D1 $E3
             $8B $87 $25 $C9 $D1 $E8 $5E8BW  $06 $03 $47 $34 $89 $46 $F2 $8B
             $5E $F2 $D1 $E3 $8E $06 $E9 $26A7W  $8B $07 $89 $46 $FC $8B $5E
             $FC $8E $06 $A1 $C8 $26 $8A $87 $42 $39 $98 $8B $56 $FC $03 $D0
             $89 $56 $FA $8B $5E $F2 $D1 $E3 $8E $06 $EB $A7 $26 $8B $07 $89
             $46 $F8 $B1 $08 $D3 $E8 $4689W  $F6 $8B $46 $F8 $25 $FF $00 $89
             $46 $F4 $8B $5E $FC $8E $06 $A1 $C8 $26 $8A $87 $A6 $44 $B4 $00
             $89 $46 $FE $B8 $0001W  $50 $50 $8B $5E $06 $FF $77 $2E $FF $77
             $34 $50 $16 $8D $46 $FA $50 $9A $16540F28RL     $83 $C4 $0E $B8
             $000FW  $50 $9A $187409F1RL     $83 $C4 $02 
                                             $8B $5E $F4 $D1 $E3 $8B $87 $25
             $C9 $D1 $E8 $E0D1W  $8B $16 $EB $A7 $8B $5E $F6 $D1 $E3 $03 $C3
             $89 $56 $F0 $89 $46 $EE $C4 $5E $EE $26 $8B $07 $89 $46 $EC $35
             $1F $00 $26 $89 $07 $5F $5E $8B $E5 $5D $CB


#################################
#Triggerable animator		#
#################################

#Single EMH spawn
%patch $EEBF $0116W

#Initiation
%patch $EA06 $FF $76 $FC $57 $9A $0FA8053CRL     $83 $C4 $04 $E9 $03E2W

#Spawn - Depress type =$0FA8053CRL
%patch $FFBC $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0001W  $C7 $47 $20 $0001W  $C7 $47 $06 $0000W
             $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89
             $47 $0C $B8 $20C6W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#Waiting action; do nothing
%patch $30F36 $00F1W $00F1W $0000W $0000W $0000W $7530W $0000W $0000W
              $00000000L    $0FA8057DRL   $09DC176ERL   $20C6W

#Sprite collision: Start activate sequence =$0FA8057DRL
%patch $FFFD $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $05
             $C7 $44 $1C $20E4W  $5F $5E $5D $CB

#Triggered sequence- returns to wait after
%patch $30F54 $00F1W $00F1W $0000W $0000W $0000W $0001W $0000W $0000W #Animate tile
              $0FA8046ERL   $00000000L    $09DC176ERL   $2102W
%patch $30F72 $00F1W $00F1W $0000W $0000W $0000W $00F0W $0000W $0000W #Wait
              $00000000L    $00000000L    $09DC176ERL   $2120W
%patch $30F90 $00F1W $00F1W $0000W $0000W $0000W $0001W $0000W $0000W #Animate tile back
              $0FA8046ERL   $00000000L    $09DC176ERL   $20C6W


#################################
#Score panel			#
#################################

#Move scorebox to screen bottom
%patch $DD8A $0B80W #Vertical location
%patch $DD91 $0000W #Horizontal location

#Lives counter location
%patch $DC94 $0004W #Vertical
%patch $DC9E $0F    #Horizontal

#Ammo counter location
%patch $DBA2 $0004W #Vertical
%patch $DBAC $19    #Horizontal

#Scorebox underflow texts
%patch $DBBB  $1846W #Text called from (Shots)
%patch $DCAE  $1846W #Text called from (Lives)

#When underflowing blank counter
%patch $306B6 $00

#Size of counters
%patch $DAF4 $0008W #Score: -1
%patch $DBF2 $0004W #Ammo: +2
%patch $DCE5 $0004W #Lives: +2

#Display
%patch $DB69 $7A22W #Time
%patch $DC64 $7A24W #Cubes left
%patch $DCA8 $7A24W #Cubes left
%patch $DCC8 $7A24W #Cubes left
%patch $DD48 $7A24W #Cubes left

#Blank counters when values are 0
%patch $DBB7 $00 $75 #Shots
%patch $DCAA $00 $75 #Lives


#################################
#Music				#
#################################

# Updated boundary between digitized sounds and IMF songs
%patch $8CEF $009EW
# Number of IMF songs
%patch $8C91 $04
# Updated pointers to the start of the song chunks
%patch $8C75 $C899W
%patch $8C83 $C899W
%patch $8D83 $C899W

#Change size and location of table
%patch $8CCD $6686W
%patch $8CA4 $63

#Music table -located over old AUDIODICT! (Peep,Squaredance,Wander,Whirl)
%patch $354F6 $0003W $0000W $0002W $0001W $0002W $0003W $0000W $0001W $0002W $0003W #Levels 0-9
              $0000W

%end